#include "myWin.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "locale.h"


//  Wϊp@include t@C
#include "stdarg.h"
#define LMAX 300
#define PI   3.14159265358979
//̃f֘A萔
#define MAX_OBJ    10		// IuWFNg̐
#define MAXPOLY    50		// \ʂ\鑽p`̐̍ő吔
#define WALL       0x10		// 
#define BALL       0x20		// {[
#define CSGM       0x30		// gݍ킹}`
#define NOINTERSEC 1E8F		// _Ȃ̒l
#define AND      1			// }`Z萔
#define OR       2
#define MINUS    3
// J[
#define RED(C)   ( C      & 0xFF)
#define GREEN(C) ((C>>8)  & 0xFF)
#define BLUE(C)  ((C>>16) & 0xFF)

typedef struct{
	double mat[4][4];
} TMatrix;
typedef struct{
	double X,Y,Z;
} Point;
typedef struct 
{
	int n;
	Point p[LMAX];
} Line;
typedef struct 
{
	int n;
	Point p[LMAX+1];
} Poly;
double diffuse;       //gUˌW
double specular;      //ʔˌW
double ambient;       //
double reflect;       //˗
double refract;       //ܗ
int  matColor ;   //̐F
//----------------------------------------------------------------------
//Point֘A֐
Point setPoint(double X,double Y, double Z){
	Point p; p.X=X;p.Y=Y; p.Z=Z; return p;
}
Point setPoint(double X,double Y){
	Point p; p.X=X;p.Y=Y; p.Z=1; return p;
}
Point setPoint(){
	Point p; p.X=0;p.Y=0; p.Z=0; return p;
}
Point add   (Point a,Point b ){return setPoint(a.X+b.X, a.Y+b.Y, a.Z+b.Z);}
Point sub   (Point a,Point b ){return setPoint(a.X-b.X, a.Y-b.Y, a.Z-b.Z);}
Point minus (Point a         ){return setPoint(   -a.X,    -a.Y,    -a.Z);}
Point mlt   (double a,Point b){return setPoint(  a*b.X,   a*b.Y,   a*b.Z);}
Point mlt   (Point a,double b){return setPoint(  a.X*b,   a.Y*b,   a.Z*b);}
Point div   (Point a,double b){return setPoint(  a.X/b,   a.Y/b,   a.Z/b);}
double mlt  (Point a,Point b ){return a.X*b.X+ a.Y*b.Y+ a.Z*b.Z;}//
Point extmlt(Point a,Point b){                                   //O 
	return setPoint(a.Y*b.Z-a.Z*b.Y, a.Z*b.X-a.X*b.Z, a.X*b.Y-a.Y*b.X);
}
bool equal(Point a, Point b){ return a.X==b.X && a.Y==b.Y && a.Z==b.Z;}
bool notequal(Point a, Point b){ return !equal(a,b) ;}
double len(Point a){ return (double)sqrt(a.X*a.X+a.Y*a.Y+a.Z*a.Z);}
Point unit(Point a){ return (len(a)==0)? setPoint(1,0,0):div(a, len(a));}
Point unit(double a, double e){// XƂ̊pxa,XYʂƂ̊pxe̒PʃxNg
	double PIR=PI/180, aa=a*PIR, ee=e*PIR;// x(degree)fBA(radian)ɕϊ
	double X=cos(aa)*cos(ee), Y=sin(aa)*cos(ee), Z=sin(ee);
	return setPoint(X,Y,Z);
}
Point unit(double a)	{// Z=0, XƂ̊pxa̒PʃxNg
	double PIR = PI/180, aa=a*PIR;// x(degree)fBA(radian)ɕϊ
	double X=cos(aa), Y=sin(aa), Z=0;
	return setPoint(X,Y,Z);
}
//---------------------------------------------------------------------------------------
//Line֘A֐
Line setLine(int N){
	if(N>LMAX){
		TCHAR str[256];
		wsprintf(str,TEXT("**Error p`̒_ő %d 𒴂܂ N = %d"),
								LMAX+1,N);
		MessageBox(NULL,str, TEXT("my3Dmat"), MB_OK);
		N=LMAX;
	}
	Line L; L.n=N;	return L;
}
Line setLine(int N, Point P0, ...){
	Line L=setLine(N); L.p[0]=P0; va_list ap; va_start(ap, P0);
	for(int i=1; i<N; i++) L.p[i]=va_arg(ap, Point);
	va_end(ap);	return L;
}
Line setLine(Point P0, Point P1){return setLine(2,P0,P1);}
Line setLine(Point P0, Point P1, Point P2){ return setLine(3, P0, P1, P2);}
Line setLine(Point P0,Point P1,Point P2,Point P3){ return setLine(4, P0, P1, P2, P3);}
Line setLine(Point P0,Point P1,Point P2,Point P3, Point P4)
{ return setLine(5, P0, P1, P2, P3, P4);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5)
{ return setLine(6, P0, P1, P2, P3, P4, P5);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6)
{ return setLine(7, P0, P1, P2, P3, P4, P5,P6);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7)
{ return setLine(8, P0, P1, P2, P3, P4, P5,P6,P7);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8)
{ return setLine(9, P0, P1, P2, P3, P4, P5,P6,P7,P8);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8,Point P9)
{ return setLine(10, P0, P1, P2, P3, P4, P5,P6,P7,P8, P9);}
Line setLine(Line b){ Line L=setLine(b.n);if(b.n>0) for(int i=0;i<b.n;i++)L.p[i]=b.p[i];return L;}
Line mlt(double a,Line b){
	Line C=setLine(b); for(int i=0;i<C.n;i++) {C.p[i].X *=a;C.p[i].Y *=a;C.p[i].Z *=a;}
	return C;
}
double len(Line a){
	double LN=0; for(int i=0;i<a.n-1;i++) LN += len(sub(a.p[i],a.p[i+1]));
	return LN;
}
Line circle_xz(int n, double b, double e){// XZʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1); double PIR = PI/180, TH = b*PIR, DTH = PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(sin(TH), 0.0, cos(TH));
	return c;
}
Line circle_xz(int n){return circle_xz(n,0,360);}// XZʂ̒Pʔả~`W
Line circle_yz(int n, double b, double e){// YZʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1); double PIR = PI/180, TH = b*PIR, DTH = PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(0.0, cos(TH), sin(TH));
	return c;
}
Line circle_yz(int n){return circle_yz(n,0,360);}// YZʂ̒Pʔả~`W
Line circle_xy(int n, double b, double e){// XYʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1);double PIR = PI/180, TH=b*PIR, DTH=PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(cos(TH),sin(TH),0);
	return c;
}
Line circle_xy(int n){return circle_xy(n,0,360);}// YZʂ̒Pʔả~`W
//---------------------------------------------------------------------------------------
//Poly֘A֐
Poly setPoly(int N){
	if(N>LMAX+1){
		TCHAR str[256];
		wsprintf(str,TEXT("**Error p`̒_ő %d 𒴂܂ N = %d"),
								LMAX+1,N);
		MessageBox(NULL,str,TEXT("my3Dmat"), MB_OK);
		N=LMAX+1;
	}
	Poly L; L.n=N;	return L;
}
Poly setPoly(int N, Point P0, ...){
	Poly P=setPoly(N + 1); P.p[0]=P0; va_list ap; va_start(ap, P0);
	for(int i=1; i<N; i++) P.p[i]=va_arg(ap, Point);
	P.p[N] = P0; va_end(ap); return P;
}
Poly setPoly(Point P0, Point P1, Point P2){ return setPoly(3, P0,P1,P2);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3)
{ return setPoly(4, P0, P1, P2, P3);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3, Point P4)
{ return setPoly(5, P0, P1, P2, P3, P4);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5)
{ return setPoly(6, P0,P1,P2, P3, P4, P5);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6)
{ return setPoly(7, P0,P1,P2, P3, P4, P5,P6);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7)
{ return setPoly(8, P0,P1,P2, P3, P4, P5,P6, P7);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8)
{ return setPoly(9, P0,P1,P2, P3, P4, P5,P6, P7,P8);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8,Point P9)
{ return setPoly(10, P0,P1,P2, P3, P4, P5,P6, P7,P8, P9);}
Poly setPoly(Point a[],int N){ 
	Poly p=setPoly(N+1);
	if(p.n>0) for(int i=0;i<p.n;i++)p.p[i]=a[i];p.p[p.n-1]=a[0]; 
	return p;
}
Poly setPoly(Line a){
	Poly p; p.n=a.n; if(a.n==0) return p;
	for(int i=0;i<a.n;i++)p.p[i]=a.p[i];
	if(notequal(a.p[0],a.p[a.n-1])){ p.n = a.n+1; p.p[a.n]=a.p[0];}
	return p;
}
Poly setPoly(Poly b){
	Poly p=setPoly(b.n); if(b.n>0) for(int i=0;i<b.n;i++)p.p[i]=b.p[i]; return p;
}
//----------------------------------------------------------------------
//TMatrix֘A֐
TMatrix setTMatrix(){
	TMatrix r;
	for(int i=0;i<4;i++)for(int j=0;j<4;j++)r.mat[i][j]=0;
	for(int i=0;i<4;i++)r.mat[i][i]=1;
	return r;
}
TMatrix setTMatrix(	 double D11, double D12, double D13,
					 double D21, double D22, double D23,
					 double D31, double D32, double D33){
	TMatrix r;
	r.mat[0][0]=D11;r.mat[0][1]=D12;r.mat[0][2]=D13;
	r.mat[1][0]=D21;r.mat[1][1]=D22;r.mat[1][2]=D23;
	r.mat[2][0]=D31;r.mat[2][1]=D32;r.mat[2][2]=D33;
	return r;
}
TMatrix setTMatrix(	double D11, double D12, double D13, double D14,
					double D21, double D22, double D23, double D24,
					double D31, double D32, double D33, double D34,
					double D41, double D42, double D43, double D44){
	TMatrix r;
	r.mat[0][0]=D11;r.mat[0][1]=D12;r.mat[0][2]=D13;r.mat[0][3]=D14;
	r.mat[1][0]=D21;r.mat[1][1]=D22;r.mat[1][2]=D23;r.mat[1][3]=D24;
	r.mat[2][0]=D31;r.mat[2][1]=D32;r.mat[2][2]=D33;r.mat[2][3]=D34;
	r.mat[3][0]=D41;r.mat[3][1]=D42;r.mat[3][2]=D43;r.mat[3][3]=D44;
	return r;
}
Point mlt(TMatrix a,Point b){
	return setPoint(	a.mat[0][0]*b.X+a.mat[0][1]*b.Y+a.mat[0][2]*b.Z+a.mat[0][3],
						a.mat[1][0]*b.X+a.mat[1][1]*b.Y+a.mat[1][2]*b.Z+a.mat[1][3],
						a.mat[2][0]*b.X+a.mat[2][1]*b.Y+a.mat[2][2]*b.Z+a.mat[2][3]);
}
Line mlt(TMatrix a,Line b){
	Line c=setLine(b.n); for(int i=0;i<c.n;i++) c.p[i]=mlt(a, b.p[i]);
	return c;
}
Poly mlt(TMatrix a,Poly b){
	Poly c=setPoly(b.n);
	for(int i=0;i<c.n;i++) c.p[i]=mlt(a,b.p[i]);
	return c;
}
TMatrix mlt(TMatrix a,TMatrix b){
	TMatrix c = setTMatrix();
	for(int i=0;i<4;i++)for(int j=0 ;j<4;j++){
		c.mat[i][j]=0;
		for(int k=0;k<4;k++) c.mat[i][j] += a.mat[i][k]*b.mat[k][j];
	}
	return c;
}
TMatrix scale(double scale_x, double scale_y, double scale_z)
{
	TMatrix m=setTMatrix();
	m.mat[0][0]=scale_x; m.mat[1][1]=scale_y; m.mat[2][2]=scale_z; 
	return m;
}
TMatrix scale(Point P){ return scale(P.X, P.Y, P.Z);}
TMatrix scale(double S){ return scale(S, S, S);}
TMatrix mlt(TMatrix a,double S){return mlt(a,scale(S));}
TMatrix mlt(double S,TMatrix a){return mlt(scale(S),a);}
TMatrix perspect(double d){
	TMatrix m=setTMatrix();
	m.mat[2][3]=-d; m.mat[3][2]=-1/d; return m;
}
TMatrix rot_x(double sn, double cs){ //X𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[1][1]=cs; m.mat[1][2]=-sn; m.mat[2][1]=sn; m.mat[2][2]=cs; 
	return m;
}
TMatrix rot_y(double sn, double cs){ //Y𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[0][0]=cs; m.mat[0][2]=sn; m.mat[2][0]=-sn; m.mat[2][2]=cs; 
	return m;
}
TMatrix rot_z(double sn, double cs){ //Z𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[0][0]=cs; m.mat[0][1]=-sn; m.mat[1][0]=sn; m.mat[1][1]=cs; 
	return m;
}
TMatrix rot_x(double r){ //X𒆐Sɉ]
	double PIR=PI/180; return rot_x(sin(r*PIR),cos(r*PIR));
}
TMatrix rot_y(double r){ //Y𒆐Sɉ]
	double PIR=PI/180; return rot_y(sin(r*PIR),cos(r*PIR));
}
TMatrix rot_z(double r){ //Z𒆐Sɉ]
	double PIR=PI/180; return rot_z(sin(r*PIR),cos(r*PIR));
}
TMatrix rotate(Point a, double sn, double cs){ //]ϊ
	Point P=setPoint(a.X, a.Y,0), axy=unit(P), axz=mlt(rot_z(-axy.Y,axy.X),unit(a));
	TMatrix M1=mlt(rot_z(axy.Y, axy.X),rot_y(-axz.Z,axz.X));
	TMatrix M2=mlt(rot_x(sn,cs), rot_y(axz.Z,axz.X));
	M2=mlt(M2,rot_z(-axy.Y, axy.X));
	return mlt(M1,M2);
}
TMatrix rotate(double r) { return rot_z(r);}
TMatrix rotate(Point a, double r){
	double PIR=PI/180; return rotate(a,sin(r*PIR),cos(r*PIR));
}
TMatrix rotate(Point a, Point b){
	double sn=len(extmlt(unit(a) , unit(b)));
	if(sn !=0) return rotate(unit(extmlt(a,b)),sn, mlt(unit(a),unit(b)));
	return setTMatrix();
}
TMatrix rotate(Point n){ //xNgɉ]
	Point   P  = setPoint(1,0,0),ss = extmlt(P,unit(n)); if(len(ss)==0) ss= setPoint(0,0,1);
	Point   s  = unit(ss);
	TMatrix t1 = rot_x(-s.Y,s.Z), t3 = rot_x(s.Y,s.Z);
	Point   m  = unit(mlt(t1,n));
	TMatrix t2 = rot_z(m.Y, m.X);
	return  mlt(mlt(t3,t2),t1);
}
TMatrix move(double x, double y, double z){
	TMatrix m=setTMatrix();
	m.mat[0][3]=x; m.mat[1][3]=y; m.mat[2][3]=z;
	return m;
}
TMatrix move(Point P) { return move(P.X, P.Y, P.Z); }

TMatrix trans(TMatrix a){
	TMatrix c=setTMatrix();
	for(int i=0; i<4; i++)
		for(int j=0; j<4; j++) c.mat[i][j]=a.mat[j][i];
	return c;
}
TMatrix inverse(TMatrix a)
{
	double d=0;
	for(int i=0; i<3; i++)
		d = d + a.mat[0][i]*a.mat[1][(i+1)%3]*a.mat[2][(i+2) % 3]
				- a.mat[0][i]*a.mat[1][(i+2)%3]*a.mat[2][(i+1) % 3];
	TMatrix b=setTMatrix();
	if(d != 0)
		for(int i=0; i<3; i++)
			for(int j=0; j<3; j++)
				b.mat[i][j]=(a.mat[(j+1)%3][(i+1)%3]*a.mat[(j+2)%3][ (i+2)%3]
							-a.mat[(j+1)%3][(i+2)%3]*a.mat[(j+2)%3][ (i+1)%3])/d;
	for(int i=0; i<3; i++) b.mat[i][3]=-a.mat[i][3];
	return b;
}
TMatrix scale(float scale_x, float scale_y, float scale_z){
	TMatrix m=setTMatrix();
	m.mat[0][0]=scale_x; m.mat[1][1]=scale_y; m.mat[2][2]=scale_z; return m;
}
//----̃fp----------------------------
int shading(Point V, Point L, Point N, int CU){
    double kd=diffuse, ks=specular, ke=ambient, D1, D2;
	Point RV=sub(L,mlt(2,mlt(mlt(L,N),N)));             //˕xNg
	D1=(mlt(minus(N),L))/(len(N)*len(L)); if(D1<0)D1=0; // gUъ
	D1=kd*D1+ke; D2=ks*(mlt(minus(RV),V))/(len(RV)*len(V));
	if( D2 < 0)D2 = 0;
	int R=(int)(D1*(double)(RED  (CU))+D2*255);if(R>255)R=255;
	int G=(int)(D1*(double)(GREEN(CU))+D2*255);if(G>255)G=255;
	int B=(int)(D1*(double)(BLUE (CU))+D2*255);if(B>255)B=255;
    return RGB(R,G,B);
}
int mix(int C1,double d1, int C2,double d2){// C1C2d1:d2ō
	int R=(int)(d1*(double)(RED  (C1))+d2*(double)(RED  (C2)));if(R>255)R=255;
	int G=(int)(d1*(double)(GREEN(C1))+d2*(double)(GREEN(C2)));if(G>255)G=255;
	int B=(int)(d1*(double)(BLUE (C1))+d2*(double)(BLUE (C2)));if(B>255)B=255;
	return RGB(R,G,B);
}
int mixColor(int c1, int c2,int c3,double a1,double a2, double a3){
	double R1=RED(c1), G1=GREEN(c1), B1=BLUE(c1);
	double R2=RED(c2), G2=GREEN(c2), B2=BLUE(c2);
	double R3=RED(c3), G3=GREEN(c3), B3=BLUE(c3);
	int R=(int)(R1*a1+R2*a2+R3*a3); if(R<0)R=0;else if(R>255) R=255;
	int G=(int)(G1*a1+G2*a2+G3*a3); if(G<0)G=0;else if(G>255) G=255;
	int B=(int)(B1*a1+B2*a2+B3*a3); if(B<0)B=0;else if(B>255) B=255;
	return RGB(R,G,B);
}	
int shading(Point V, Point L, Point N, int CU, double s){
	double kd=diffuse, ks=specular, ke=ambient, D1, D2;
	Point RV=sub(L,mlt(mlt(mlt(2,L),N),N));            //˕xNg
	D1=mlt(minus(N),L)/(len(N)*len(L));if(D1<0)D1=0;// gUъ
	D1=kd*s*D1+ke; 
	D2=s*ks*mlt(minus(RV),V)/(len(RV)*len(V)); if(D2<0)D2=0;// 
	int R=(int)(D1*(double)(RED(CU)  )+D2*255);if(R>255)R=255;
	int G=(int)(D1*(double)(GREEN(CU))+D2*255);if(G>255)G=255;
	int B=(int)(D1*(double)(BLUE(CU) )+D2*255);if(B>255)B=255;
	return RGB(R,G,B);
}
typedef struct{
	int n; Poly p[MAXPOLY];
} Surface;

Surface setSurface(int n)   { Surface S; S.n=n; return S;}
Surface setSurface(Poly a)  { Surface S; S.n=1; S.p[0]=setPoly(a);return S;}
Surface setSurface(Surface a) {
	Surface S; S.n=a.n;
	for(int i=0;i<a.n; i++) S.p[i]=a.p[i];
	return S;
}
Surface mlt(TMatrix a, Surface b){
	Surface c=setSurface(b.n); 
	for(int i=0; i<c.n;i++) c.p[i]=mlt(a, b.p[i]);
	return c;
}
typedef struct{	Point o,d; } Ray;
Ray setRay(Point O, Point D){Ray R; R.o=O;R. d=D;return R;}
typedef struct{ Point o; double r;} Ball;
Ball setBall(Point O, double R){Ball B; B.o=O;B.r=R; return B;}
Ball setBall(Point O){Ball B; B.o=O;B.r=0;return B;}
Ball setBall(){Ball B; B.o=setPoint(0,0,0);B.r=0;return B;}
double hit(Ball B, Ray VR, Point *P, Point *N)
{
	double ds=mlt(VR.d,sub(VR.o,B.o));
	double d2=ds*ds-mlt(sub(VR.o,B.o),sub(VR.o,B.o)) + B.r*B.r;
	if(d2<0) return 1E+8F;
	double t= -ds - sqrt(d2);
	//if(t<0.5) t= -ds + Math.Sqrt(d2);
	*P=add(VR.o, mlt(t ,VR.d)); *N=unit(sub(*P,B.o));
	return t;
}
double hitV(Ball B, Ray VR, Point *P, Point *N)
{
	 double ds=mlt(VR.d, sub(VR.o, B.o));
	 double d2=ds*ds-mlt(sub(VR.o, B.o), sub(VR.o,B.o))+B.r*B.r;
	 if(d2<0) return 1E+8F;
	 return ( -ds - sqrt(d2));
}
bool In(Ball B, Point P){//̓ǂ̔
  double L=len(sub(P,B.o));
  //if(abs(L-B.r)<0.0001) return true;
  if(L<=B.r) return true;
  else return false;
}
double hitIn(Ball B, Ray VR,Point *P, Point *N)	{//\p
	double ds=mlt(VR.d,sub(VR.o,B.o));
	double d2=ds*ds-mlt(sub(VR.o,B.o),sub(VR.o,B.o))+B.r*B.r;
	if(d2<0) return 1E+8F;
	double t= -ds + sqrt(d2);
	*P=add(VR.o,mlt(t , VR.d)); *N=unit(sub(*P, B.o));
	return t; 
}

typedef struct{ int n; Poly p; Point nv;} Wall;
Wall setWall(Poly pi){
	Wall W;
	W.p=setPoly(pi); W.n=W.p.n;
	W.nv=unit(extmlt(sub(W.p.p[0],W.p.p[2]), sub(W.p.p[1],W.p.p[3])));
	return W;
}
double hit(Wall W, Ray VR,Point*P, Point*N)
{
	double t=mlt(W.nv, sub(W.p.p[1], VR.o))/mlt(W.nv, VR.d);  //
	if(t<=0) return 1E+8F;
	*P=add(VR.o, mlt(t, VR.d)); *N=W.nv;
	for(int i=0; i<W.n-1; i++)
		if(mlt(*N,(extmlt(sub(W.p.p[i+1],W.p.p[i]),sub(*P,W.p.p[i]))))<0)return 1E+8F;
	return t;
}
typedef struct{
		int c;
		int numTx;
		int tx[20];                 // FC͗l
		double kd,ks,ke;             // gU˗, ʔ˗, W
		double kr,kn,kt;             // ˗, ܗ, ߗ
		int wi, hi;                 // EChETCY
		int numRn;
		int rn[20];
} Attr;
Attr setAttr(int C, double D, double S, double E, double R, double N, double T){
	Attr a;	a.c=C; a.kd=D; a.ks=S; a.ke=E; a.kr=R; a.kn=N; a.kt=T; a.wi=0; 
	a.numTx=0; a.numRn=1;a.rn[0]=1; return a;
}
Attr setAttr(int C, double D, double S, double E, double R, double N){
	Attr a;	a.c=C; a.kd=D; a.ks=S; a.ke=E; a.kr=R; a.kn=N; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1;a.rn[0]=1;return a;
}
Attr setAttr(int C, double D, float S, float E, float R){
	Attr a;	a.c=C; a.kd=D; a.ks=S; a.ke=E; a.kr=R; a.kn=0; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1;a.rn[0]=1; return a;
}
Attr setAttr(int C, double D, float S, float E){
	Attr a; a.c=C; a.kd=D; a.ks=S; a.ke=E; a.kr=0; a.kn=0; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1; a.rn[0]=1;return a;
}
Attr setAttr(int C, double D, float S){
	Attr a; a.c=C; a.kd=D; a.ks=S; a.ke=0.2; a.kr=0; a.kn=0; a.kt=1; a.wi=0; 
	a.numTx=0; a.numRn=1; a.rn[0]=1; return a;
}
Attr setAttr(int C, double D){
	Attr a; a.c=C; a.kd=D; a.ks=0.8; a.ke=0.2; a.kr=0; a.kn=0; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1; a.rn[0]=1; return a;
}
Attr setAttr(int C){
	Attr a;  a.c=C; a.kd=0.7; a.ks=0.8; a.ke=0.2; a.kr=0; a.kn=0; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1; a.rn[0]=1; return a;
}
Attr setAttr(){ 
	Attr a;  a.c=0xFFFFFF; a.kd=0.7; a.ks=0.8; a.ke=0.2; a.kr=0; a.kn=0; a.kt=1; a.wi=0;
	a.numTx=0; a.numRn=1; a.rn[0]=1; return a;
}
Attr setAttr(Attr b){ Attr a = b; return a;}
int shading(Point V, Point L, Point N, Attr A, double s){
	Point RV=sub(L, mlt(2, (mlt(mlt(L, N), N))));			
	double D1=mlt(minus(N),L)/(len(N)*len(L)); // gUъ
	if(D1<0)D1=0;
	D1=A.kd*s*D1+A.ke; double D2 = s*A.ks*(mlt(minus(RV),V))/(len(RV)*len(V));// 
	if(D2<0)D2=0;
	int R=(int)(D1*(double)RED(A.c)+D2*255);if(R>255)R=255;
	int G=(int)(D1*(double)GREEN(A.c)+D2*255);if(G>255)G=255;
	int B=(int)(D1*(double)BLUE(A.c)+D2*255);if(B>255)B=255;
	return RGB(R,G,B);
}

typedef struct {//Wϊp
	int type;             //
	TMatrix A;            //2W
	Point   B;            //1W
	double  C;            //0W
} Quad;

Quad setQuad() { 
	Quad q; q.type=0; q.C=0; q.A=setTMatrix();q.B=setPoint(0,0,0);
	return q;
}
Quad setQuad(Point s2, Point s1, double s0){
	Quad q;	q.A=scale(s2);q.B=s1;q.C=s0;
	if     (notequal(s2, setPoint(0,0,0))) q.type=2;
	else if(notequal(s1, setPoint(0,0,0))) q.type=1;
	else                                   q.type=0;
	return q;
}
bool inner(Quad q, Point P){
	if(q.type==1)if((mlt(P,q.B) + q.C)<=0) return true;else return false;
	else if(mlt(mlt(q.A,P), P)+ mlt(q.B,P)+q.C<=0) return true;
	return false;
}
double hit(Quad q, Ray VR, Point *P, Point *N){
	Point V0 = VR.o, V  = VR.d; double t  = 1E8F, ad = 0; 
	if(q.type ==0) return t;
	if(q.type ==1) { t = -(mlt(q.B,V0)+q.C)/mlt(q.B,V);}
	else{
		double a = mlt(mlt(q.A,V),V), b=mlt(add(mlt(mlt(2,q.A),V0),q.B),V);
		double c=mlt(add(mlt(q.A,V0),q.B),V0)+ q.C, d = b*b-4*a*c;
				if(d<0) return 1E8F;
				ad=sqrt(d)/abs(2*a);
				t=-b/(2*a)-ad;
				if(t<0.5) t+=2*ad;
	}
	if(t<0.5) return 1E8F;
	*P=add(VR.o,mlt(t, VR.d));
	*N=unit(add(mlt(mlt(2,q.A),*P), q.B));
	return t;
}
Quad mlt(TMatrix a,Quad b){
	Quad q=b;
	TMatrix r=inverse(a);
	Point o=minus(mlt(a,(setPoint(0,0,0))));
	r.mat[0][3]=r.mat[1][3]=r.mat[2][3]=0;
	q.A=mlt(mlt(trans(r),b.A),r); q.B=add(mlt(trans(r),b.B),mlt(mlt(2,q.A),o));
	q.C=b.C+mlt(sub(q.B, mlt(q.A, o)),o);
	return q;
}
Quad minus(Quad b){
	Quad q=b; q.A=mlt(-1,b.A);q.B=minus(b.B); q.C=-b.C; return q;
}
struct Csgm0{// }`\\\(Constructive Solid Geometry Model)
		struct Csgm0 * c1, *c2;//qCsgm
		Quad h1;
		int op; //ZR[h(AND/OR/MINUS)
		Ball BV;
};
typedef Csgm0 Csgm;
Csgm setCsgm(){	Csgm c; c.op=0;c.h1=setQuad(); return c;}
Csgm setCsgm(Point s2,Point s1,double s0){
	Csgm c; c.h1=setQuad(s2,s1,s0);c.op=0;
	return c;
}
Csgm minus(Csgm b){
	Csgm  c=b; if(b.op==0){ c.h1=minus(b.h1);return c;}
	if(b.op==AND) c.op=OR; else if(b.op==OR) c.op=AND;
    c.c1=&minus(*(b.c1));c.c2=&minus(*(b.c2)); return c;
}
Csgm setCsgm(Csgm a,Csgm b, int md){
    Csgm c;	c.BV=setBall(setPoint(0,0,0),-1);
	c.c1 = &setCsgm(); c.c2=&setCsgm();
	if(md==MINUS){c.c2 = &minus(b); c.op=AND;}
	else         {c.c2 = &b;  c.op=md;}
	c.c1=&a; return c;
}
Csgm setCsgm(Csgm a,Csgm b){ return setCsgm(a,b,0);}
Csgm setCsgm(Csgm a){
	Csgm c;	c.BV=a.BV; c.c1=&setCsgm();c.c2=&setCsgm();c.h1=setQuad();
	if(a.op==0)	{c.c1=a.c1;c.c2=a.c2;} else c.h1=a.h1;
	c.op=a.op; return c;
}
Csgm setCsgm(Csgm a, Ball bv){
	Csgm c; c.BV=bv; c.c1=&setCsgm();c.c2=&setCsgm();c.h1=setQuad();
	if(a.op==0){c.c1= a.c1;c.c2=a.c2;} else c.h1=a.h1;
	c.op=a.op; return c;
}
Csgm mlt(TMatrix a,Csgm b){
	Csgm  c=b; if(b.op==0){ c.h1=mlt(a,(b.h1));return c;}
	c.c1=&mlt(a,(*(b.c1)));c.c2=&mlt(a,(*(b.c2))); return c;
}
Csgm add(Csgm a, Csgm b){return setCsgm(a,b,OR);}
Csgm sub(Csgm a, Csgm b){return setCsgm(a,b,MINUS);}
Csgm operator *(Csgm a, Csgm b){return setCsgm(a,b,AND);}
bool inner(Csgm c, Point P){
	if(c.op==AND) return inner(*(c.c1), P) && inner(*(c.c2),P);
	if(c.op==OR)  return inner(*(c.c1),P) || inner(*(c.c2),P);
	return inner(c.h1, P);
}
bool outer(Csgm c, Point P){ return !inner(c, P);}
double hit(Csgm c, Ray VR,Point *P, Point *N){
	if((c.BV.r>0) && (hit(c.BV, VR,P,N)>=NOINTERSEC)) return NOINTERSEC;
	Point P1=setPoint(),P2=setPoint(),N1=setPoint(),N2=setPoint();
	double t1,t2;
	if(c.op==AND){
		Ray V=VR;
		for(int i=0;i<10;i++){
			t1=hit(*(c.c1), V, &P1,&N1); t2=hit(*(c.c2), V, &P2,&N2);
			if(t1>=NOINTERSEC && t2>=NOINTERSEC) return NOINTERSEC;
			if(abs(t1-t2)<0.5){
				Point PP=add(V.o , mlt((max(t1,t2)+0.5),V.d));
				if(inner(*(c.c1),PP) && inner(*(c.c2),PP))
				{ *P=add(V.o, mlt(max(t1,t2),V.d)); *N=N1; return len(sub(VR.o,*P));}
				else return NOINTERSEC;
			}
			if(t1<t2)
				if     (inner(*(c.c2), P1)){*N=N1;*P=P1; return len(sub(VR.o,P1));}
				else                       {V.o=P1;}
				else if(inner(*(c.c1), P2)){*N=N2;*P=P2; return len(sub(VR.o,P2));}
				else                       {V.o=P2;}
		}
		return NOINTERSEC;
	}
	else if(c.op==OR){
		Ray V=VR;
		for(int i=0;i<10;i++){
			t1=hit(*(c.c1),V, &P1, &N1); t2=hit(*(c.c2), V, &P2, &N2);
			if(t1>= NOINTERSEC && t2>= NOINTERSEC) return  NOINTERSEC;
			if(t1<t2)
				if(outer(*(c.c2), P1)){*N=N1;*P=P1; return len(sub(VR.o,P1));}
				else                  {V.o=P1;}
			else if(outer(*(c.c1),P2)){*N=N2;*P=P2; return len(sub(VR.o,P2));}
			else                      {V.o=P2;}
		}	
	}
	else if(c.op==0) return hit(c.h1, VR,P,N);
	return NOINTERSEC;
}
Csgm ball(Point s)	{
	Point s2=setPoint((s.X==0)?0:1/(s.X*s.X),(s.Y==0)?0:1/(s.Y*s.Y),(s.Z==0)?0:1/(s.Z*s.Z));
	return setCsgm(s2, setPoint(0,0,0),-1);
}
Csgm ball    (double r)         { return ball(setPoint(r,r,r));}
Csgm cylinder(Point s)          { return ball(s);}
Csgm plane   (Point a, double b){ return setCsgm(setPoint(0, 0, 0), a, b);}
Csgm plane   (Point a)          { return plane(a,0);}
Csgm plane_xy()                 { return setCsgm(setPoint(0, 0, 0), setPoint(0, 0, 1),0);}
Csgm plane_yz()                 { return setCsgm(setPoint(0, 0, 0), setPoint(1, 0, 0),0);}
Csgm plane_xz()                 { return setCsgm(setPoint(0, 0, 0), setPoint(0, 1, 0),0);}
Csgm boad_xy(double b){  
	return (setCsgm(setPoint(0, 0, 0), setPoint(0, 0, -1),-b/2))*
			       (setCsgm(setPoint(0, 0, 0), setPoint(0, 0,  1),-b/2));
}
typedef struct {
	Wall w; Ball b; Csgm  c; int type; Attr attr; int elem;
} Obj;
Obj setObj(Wall W, Attr a){Obj o; o.w=W;o.type=WALL; o.attr=a;return o;} 
Obj setObj(Ball B, Attr a){Obj o; o.b=B;o.type=BALL; o.attr=a;return o;} 
Obj setObj(Csgm C, Attr a){Obj o; o.c=C;o.type=CSGM; o.attr=a;return o;} 
typedef struct {
	Obj   obj[MAX_OBJ];//
	int   n;           //̂̌
	int   bgc;         //wiF
	bool  md;          //\̗L
} Scene;
Scene setScene(int C, bool M){
	Scene s; s.n=0; s.md = M   ; s.bgc = C;
	return s;
}
Scene setScene(int C){
	Scene s; s.n=0; s.md = true; s.bgc = C;
	return s;
}
Scene setScene(){
	Scene s; s.n=0; s.md = true; s.bgc = 0;
	return s;
}
int bgcolor(Scene s, Ray VR) 
{return s.bgc;}
Scene regist(Scene s, Wall a,Attr c){ s.obj[s.n++]=setObj(a,c); return s;}
Scene regist(Scene s, Ball a,Attr c){ s.obj[s.n++]=setObj(a,c);	return s;}
Scene regist(Scene s, Csgm a,Attr c, Ball bv){ 
	Csgm X =setCsgm(a, bv);	s.obj[s.n++]=setObj(X,c); return s;
}
Scene regist(Scene s,Csgm a,Attr c)	{
	Csgm X =setCsgm(a,setBall(setPoint(0,0,0),-1)); s.obj[s.n++]=setObj(X,c);
	return s;
}
Attr setAttr(Scene s,int i,Point P,Point N){return s.obj[i].attr;}
int hit(Scene s, Ray VR, Point *P, Point *N, int *hi){
	double t=NOINTERSEC, tt=0;
	Point HP=setPoint(0,0,0),HN=setPoint(0,0,0);
	*hi=-1;
	for(int i=0;i<s.n; i++){
		if     (s.obj[i].type==WALL) tt=hit(s.obj[i].w,VR,&HP,&HN);
		else if(s.obj[i].type==BALL) tt=hit(s.obj[i].b,VR,&HP,&HN);
		else if(s.obj[i].type==BALL) tt=hit(s.obj[i].b,VR,&HP,&HN);
		if(tt>0.5 && tt<t) { t=tt; *hi=i; *P=HP; *N=HN;}
	}
	return *hi;
}
double trans(Scene s, Ray VR,double L){ //Ɩ̋
	double sd=1, tt=0;
	Point HP=setPoint(0,0,0),HN=setPoint(0,0,0);
	for(int i=0;i<s.n; i++)	{
		if     (s.obj[i].type==WALL)tt=hit(s.obj[i].w,VR,&HP,&HN);
		else if(s.obj[i].type==BALL)tt=hit(s.obj[i].b,VR,&HP,&HN);
		else if(s.obj[i].type==BALL)tt=hit(s.obj[i].b,VR,&HP,&HN);
		if(tt>0.5 && tt<L-0.5)
			if(s.obj[i].attr.kn<=0)sd=0; else sd *= (1-s.obj[i].attr.kr);
		if(sd<=0) break;
	}
	return sd;
}
int color(Scene s, Ray VR, Point *L0,int *rn, double am){
	if((rn==0) || (am<0.01)) return 0;
	Point Ps=setPoint(0,0,0), N=setPoint(0,0,0);
	int hi=-1, rnt=*rn-1,rnr=*rn-1;   // hi: ̂̔ԍ
	if(hit(s, VR,&Ps,&N,&hi)<0){ rn=0; return bgcolor(s,VR);}
	int Cs=0, Cr=0, Ct=0;
	Attr A  = setAttr(s, hi, Ps,N);
	double kr = A.kr;
	Point L  = unit(sub(Ps,*L0));                //ƖxNg
	Ray   LR = setRay(Ps,minus(L));             //Ɩ`
	double sf  = trans(s, LR, len(sub(*L0,Ps)));      //_A
	Cs=shading( VR.d,L,N,A,sf);                   //_g̐F
	if(A.kn>0){                                  //܌
		double n=A.kn;                      
		if(mlt(N,VR.d)>0) {n=1/n; N=minus(N);}        //̂oꍇ
		double c = mlt(minus(VR.d),N), g2 = n*n+c*c-1;
		if(g2>0) {                          //S˂łȂꍇ
			double g=sqrt(g2);
			Ray   TR = setRay(Ps, div(add(VR.d,mlt((c-g),N)),n));
			double cmg=c-g, cpg=c+g, nmg=n*n*c-g, npg=n*n*c+g;
			kr = (cmg*cmg/(cpg*cpg)+nmg*nmg/(npg*npg))/2;
			Ct = color(s,TR,L0,&rnt, am*(1-kr)*A.kt);
		}
		else kr=1;                         //S
	}
	if(kr>0) {
		if(mlt(N,VR.d)>0) N=minus(N);
		Ray RR=setRay(Ps,sub(VR.d,mlt(2,(mlt(mlt(VR.d,N),N))))); // ˎ`
		Cr=color(s,RR,L0,&rnr,am*kr);    // ˎ_猩镨̐F
	}
	*rn=((rnr>rnt)?rnr:rnt)+1;
	return mixColor(Cr,Ct,Cs,kr,(1-kr)*A.kt,1);
}
int color(Scene s, Ray VR, Point *L0,int rn){
	int r=rn; return color(s, VR,L0,&r,1);
}
//----̃fpI----------------------------
static HDC hbuf; static HBITMAP hBM;//rbg}bv`p
// ̕\p
Point org, v0;        //_A_ʒu
TMatrix t, it;        //ϊ}gbNX
double dv;            //Zɂ炷
double size_x, size_y;//\ʃTCY
void clearBitmap(){   //rbg}bvNA
	SelectObject(hbuf,GetStockObject(NULL_PEN));
	PatBlt(hbuf,0,0,2000,1000,WHITENESS);
}
void setView(double a,double e, double d){ // pxɂݒ
	Point P1=setPoint(0,0,1);
	TMatrix PP=perspect(d), RX=rot_x(e-90), RZ=rot_z(-90-a);
	t=mlt(mlt(perspect(d),rot_x(e-90)),rot_z(-90-a));
	v0=mlt(mlt(rot_z(90+a),rot_x(90-e)),mlt(P1,d));
}
void setview(Point p){//_ʒuɂݒ
	Point P1=setPoint(0,0,1); dv=len(p);
	Point wa=unit(p); v0=p;
	if((wa.X==0) &&(wa.Y==0)){ t=perspect(dv);return;}
    double wd=sqrt(wa.X*wa.X+wa.Y*wa.Y);
    t=mlt(mlt(perspect(dv),rot_x(-wd,wa.Z)),rot_z(-wa.X/wd,-wa.Y/wd));
	it=mlt(rot_z(wa.X/wd,-wa.Y/wd),rot_x(wd,wa.Z));
}
Point screen(Point p){//XN[Wnւ̕ϊ
	Point a=mlt(t,p);
	double s=(t.mat[3][0]*p.X+t.mat[3][1]*p.Y+t.mat[3][2]*p.Z+t.mat[3][3]);
	return setPoint(org.X+a.X/s,org.Y-a.Y/s,a.Z);
}
Point world(Point p){ //ViewWWorldWɕϊ
	double sz=-p.Z/dv;
	return mlt(it,(setPoint((p.X-org.X)*sz,(-p.Y+org.Y)*sz,p.Z+dv)));
}
void init2D(int x, int y){//`揉ݒ
	size_x=x; size_y=y;	org.X=size_x/2-0.5;	org.Y=size_y/2-1.5; org.Z=0;
	setView(30,30,1000);
}
void origin(int x, int y){ org = setPoint(x+0.5F , y-0.5F,0); }//_ݒ
void drawPoint(double x,double y, int C){//_`
	SetPixel(hbuf,(int)(x+0.5), (int)(y+0.5),C);
}
void createBitmap(HWND hw){
	HDC hdc=GetDC(hw); hBM=CreateCompatibleBitmap(hdc,500,700);
	hbuf=CreateCompatibleDC(hdc);SelectObject(hbuf,hBM);
	ReleaseDC(hw, hdc);
}
void windowSize(HWND hw, int width,int height){
	RECT r;	GetWindowRect(hw, &r);
	MoveWindow(hw, r.left, r.top, width, height,TRUE);
}
void createLabel(HWND hw, LPARAM lp, HMENU hm, int X, int Y,TCHAR *str){//x
	CreateWindow(TEXT("STATIC"),str,
		WS_CHILD|WS_VISIBLE|SS_RIGHT, X,Y,100,20,hw,hm,
		hInstance, NULL);
}
HWND createEdit(HWND hw, LPARAM lp,HMENU hm, int X, int Y, TCHAR *str){//GfBbg{bNX
	return CreateWindow(TEXT("EDIT"),str, 
		WS_CHILD|WS_VISIBLE|WS_BORDER|ES_RIGHT, 
		X,Y,50,20,hw,hm,hInstance, NULL);
}
HWND createButton(HWND hw, LPARAM lp,HMENU hm, int X, int Y, TCHAR str[]){//{^
	return CreateWindow(TEXT("BUTTON"),str,
		WS_CHILD|WS_VISIBLE|WS_BORDER|BS_PUSHBUTTON, 
		X,Y,140,30,hw,hm,hInstance, NULL);
}
double getValue(HWND editBox){//GfBbg{bNX̒loB
	TCHAR str[128];char ansi[256];double X;
	GetWindowText(editBox,str,127);//o
	WideCharToMultiByte(CP_ACP, 0, str,-1,ansi,255,NULL,NULL);//charzɕϊ
	sscanf(ansi,"%lf",&X); //_ϊ
	return X;
}
typedef struct{
	HBITMAP h; BITMAP  b;
} myBitmap;
myBitmap createMyBitmap(HWND hw, TCHAR str[]){
	myBitmap txt;
	txt.h=LoadBitmap(hInstance,str);HDC hdc=GetDC(hw);
	GetObject(txt.h, sizeof(BITMAP), &txt.b);
	return txt;
	
}
HDC startBitmap(myBitmap txt){
	HDC hdctx =CreateCompatibleDC(hbuf);
	SelectObject(hdctx,txt.h); SetStretchBltMode(hdctx,COLORONCOLOR);
	return hdctx;
}
void drawBitmap(HDC hdctx, myBitmap txt,int x, int y, double SX, double SY){ 
	StretchBlt(hbuf,x,y,(int)(txt.b.bmWidth*SX), (int)(txt.b.bmHeight*SY),
				hdctx, x,y,txt.b.bmWidth, txt.b.bmHeight, SRCCOPY);
}
